
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>linux嵌入式驱动-总线设备驱动模型 / 憋错料</title>

    <meta name="description" content="linux嵌入式驱动-总线设备驱动模型 一个农夫想要合理的理财,他给你未来N天的每天支出(1&lt;=N&lt;=100000), 并计划把这N天分成M个部分(1 &lt;=M &lt;=N)(每个部分的天数是连续的),要求求出这些部分里花费最和最大值最小,输出这个最大值. 100 400 300 100 500 101 400 可以这么划分(100 400) (300 100) (500) (101)(400) ,五个分组里最大值是500,这个划是最佳的了,因为在其他划分里肯定有部分是大于500的,如(100) (400 300)  ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">linux嵌入式驱动-总线设备驱动模型</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>一个农夫想要合理的理财，他给你未来N天的每天支出（1&lt;=N&lt;=100000）, 并计划把这N天分成M个部分(1 &lt;=M &lt;=N)（每个部分的天数是连续的）,要求求出这些部分里花费最和最大&#20540;最小，输出这个最大&#20540;。</p>
<p>100 400 300 100 500 101 400 可以这么划分（100 400） （300 100） （500） （101）（400） ，五个分组里最大&#20540;是500，这个划是最佳的了，因为在其他划分里肯定有部分是大于500的，如（100） （400 300） （100 500）（101） （400）。</p>
<p>分析：</p>
<p>典型的二分，我们可以二分求最大&#20540;，上界是把所有的都分一组，也就是所有天数的和，下界是把每天当成一组的最大&#20540;。然后二分这个最大&#20540;，求解。</p>
<p>关于如何判断mid&#20540;。 我们依照mid&#20540;来分组，如果当前部分的和大于了mid&#20540;，那么分组加一，在进行下一组的划分。二分能够找到最小的一个&#20540;使得恰好分成M组。</p>
<pre>#include &lt;stdio.h&gt;
#include &lt;string.h&gt;
#include &lt;algorithm&gt;

using namespace std;

const int M = 100005;

int a[M];
int n, m;

int group(int v)          //依照V值分组  返回分组数
{
    int cnt = 1;
    int sum = 0;
    for (int i = 1; i &lt;= n; i++)
    {
        sum += a[i];
        if (sum &gt; v)
        {
            cnt++;
            sum = a[i];
        }
    }
    return cnt;
}

int bsearch(int l, int r)
{
    if (l == r)
        return l;
    int mid = (l+r)&gt;&gt;1;
    if (m &gt;= group(mid))
        return bsearch(l, mid);
    else
        return bsearch(mid+1, r);
}

int main()
{
    while (scanf(&quot;%d %d&quot;, &amp;n, &amp;m) != EOF)
    {
        int right = 0;
        int lift = 0;
        for (int i = 1; i &lt;= n; i++)
        {
            scanf(&quot;%d&quot;, &amp;a[i]);
            right += a[i];                      //right是上界， lift是下界
            lift = max(lift, a[i]);
        }
        int ans = bsearch(lift, right);
        printf(&quot;%d\n&quot;, ans);
    }
    return 0;
}</pre>
<p><P><A href="http://www.bubuko.com/infodetail-166590.html" rel="external nofollow noreferrer">linux嵌入式驱动-总线设备驱动模型,布布扣,bubuko.com</A></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 22:28:58 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/%e4%ba%8c%e5%88%86/" title="二分">二分</a>, <a href="https://www.biecuoliao.com/tag/poj/" title="poj">poj</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>linux嵌入式驱动-总线设备驱动模型的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xQODQ3.html" rel="bookmark">linux总线设备驱动模型</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本篇文章通过平台总线设备模型为例,讲解总线设备驱动模型: platform_device_register的作用: 1.把device放入bus的device链表 2.从bus的driver链表中取出每一个driver,用bus的match函数判断driver能否支持这个device 3.若可以支持,调用driver的probe函数 platform_driver_register的作用: 1.将driver放入bus的driver链表 2.从bus的device链表中取出每一个device,用			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MmD97K4.html" rel="bookmark">总线设备驱动模型</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.总线模型(转自国嵌论坛) 1.随着技术的进步,对热插拔的要求以及可移植性的要求越来越高,从Linux2.4开始虽然有了模型但是正式提出是在Linux2.6. 2.关键词是总线,驱动,设备 3.总线能够感知设备的插拔: (1)插入新设备的时候知道有设备插入,那么就去总线上已有的驱动里面查找能够处理该新设备的驱动,一旦匹配,该驱动就有了该设备的控制权 (2)拔出的时候,总线也能感知,并且告诉相应的驱动从而使得驱动能够处理拔出事件二.总线 1.描述结构 linux内核中总线由bus_type结构描			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPD96DM.html" rel="bookmark">8&period;总线设备驱动模型</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				总线设备驱动模型 总线:创建一条总线,跟我们前面的按键一样,首先是描述总线结构,接着是注册总线,注销总线.总线设备,例如usb总线,上面会有很多类型的usb的驱动,例如鼠标.键盘.....等,当我们把之一的usb插上的时候,usb总线会把每个驱动遍历一遍,找到相应的驱动程序执行. 接下来用bus.c创建一条总线. #include &lt;linux/init.h&gt; #include &lt;linux/module.h&gt; #include &lt;linux/kernel.h&gt; #in			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/41o1ro0.html" rel="bookmark">20150225 IMX257 总线设备驱动模型编程之总线篇</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				20150225 IMX257 总线设备驱动模型编程之总线篇 2015-02-25 19:40 李海沿 从现在开始,我们开始来实现 总线-设备-驱动模型中的总线.. 我们这个程序的目标是在 sysfs文件系统的/sys/bus/ 目录下面建立一个文件夹. 一.总线介绍 1. 总线数据结构bus_type struct bus_type 结构体的定义如下: struct bus_type { const char *name; --总线名 struct bus_attribute *bus_att			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/38pQGn3.html" rel="bookmark">总线设备驱动模型【转】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文转载自:http://blog.csdn.net/coding__madman/article/details/51428400 总线驱动设备模型: 1. 总线设备驱动模型概述 随着技术的不断进步,系统的拓扑结构也越来越复杂,对热插拔,跨平台移植性的要求也越来越高,2.4内核已经难以满足这些需求,为适应这宗形势的需求,从linux2.6内核开始提供了全新的设备模型 2. 总线 2.1 描述结构 2.2 注册 2.3 注销 void  bus_unregister(struct  bus_ty			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MyqBJnM.html" rel="bookmark">16&period;总线设备驱动模型学习</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				总线设备驱动模型学习 一.总线概述 随着技术的不断进步,系统的拓扑结构也越来越复杂,对热插拔,跨平台移植性的要求也越来越高,2.4内核已经难以满足这些需求.为适应这种形势的需要,从Linux 2.6内核开始提供了全新的设备模型. 总线:创建一条总线,跟按键一样,首先是描述总线结构,接着是注册总线,注销总线.总线设备,例如usb总线,上面会有很多类型的usb的驱动,例如鼠标.键盘.....等,当我们把之一的usb插上的时候,usb总线会把每个驱动遍历一遍,找到相应的驱动程序执行. 1.1总线描述			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDkm684.html" rel="bookmark">20150226 IMX257 总线设备驱动模型编程之平台总线设备platform</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				20150226 IMX257 总线设备驱动模型编程之平台总线设备platform 2015-02-26 李海沿 前面我们实现了总线设备驱动模型,下面我们来了解一下平台总线,平台设备驱动 分为平台设备和平台驱动两种,和前面所说的设备驱动差不多 platform总线是一种虚拟的总线,相应的设备则为platform_device,而驱动则为platform_driver.Linux 2.6的设备驱动模型中,把I2C.RTC.LCD等都归纳为platform_device. 一.平台设备介绍 1. p			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MyqYkaM.html" rel="bookmark">20150226 IMX257 总线设备驱动模型编程之设备篇</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				20150226 IMX257 总线设备驱动模型编程之设备篇 2015-02-26 李海沿 前面我们呢实现了总线-设备-驱动模型中的总线,自然,我们的目标就是在我们建立的总线下面创建一个设备. http://www.cnblogs.com/lihaiyan/p/4301072.html 一.程序分析 1. 包含总线 既然我们的设备在总线上,自然我们既要包含总线了 如图所示,使用外部声明将我们的总线的结构体包含进来 2. 定义设备结构体 父目录为 my_bus 3. 定义属性文件结构体 属性文件结			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MWx92G0.html" rel="bookmark">20150226 IMX257 总线设备驱动模型编程之驱动篇</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				20150226 IMX257 总线设备驱动模型编程之驱动篇 2015-02-26 11:42 李海沿 前面我们已经实现了 总线和设备 的驱动程序,接下来我们的任务就是 实现 驱动 了 地址:http://www.cnblogs.com/lihaiyan/p/4301079.html http://www.cnblogs.com/lihaiyan/p/4301072.html 在实现驱动程序之前,我们来想两个问题: 一.问题分析 1.什么时候驱动程序会在总线上找它可以处理的设备? 在driver			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lG2vNM.html" rel="bookmark" class="title">Objective-C 学习记录4</a>
					<div>
						字符串的一些方法使用: 1.创建字典的NSString可变字符串,和NSMutableString不可变字符串.都是objective的对象. char *str是字母数组. 2.字符串格式化:str ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MB1wng4.html" rel="bookmark" class="title">程序媛计划&mdash;&mdash;mysql外键</a>
					<div>
						定义 外键:如果一个表的某个字段指向另一个表的主键,就称之为外键.被指向的表,称之为主表,也叫父表,那么另一个表就是从表,也叫子表 #先新建两个表 mysql&gt; create table aut ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pRVqV0.html" rel="bookmark" class="title">zabbix之日志监控</a>
					<div>
						一.日志item介绍 下面介绍zabbix另一个&quot;重量级&quot;的功能--日志文件监控,它最主要的是监控日志文件中有没有某个字符串的表达式,对应日志轮转与否,zabbix都支持. 在配置 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZDE8lM.html" rel="bookmark" class="title">KVM ---- 虚拟磁盘扩容</a>
					<div>
						磁盘不够使用,添加新的硬盘,或者扩容当前磁盘. 1.子机的当前磁盘状态 母机中查看该系统 [[email protected] ~]# qemu-img resize /caimz/caimz2.im ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPWEJa4.html" rel="bookmark" class="title">&lbrack;BZOJ&rsqb;4817&colon; &lbrack;Sdoi2017&rsqb;树点涂色</a>
					<div>
						Time Limit: 10 Sec  Memory Limit: 128 MB Description Bob有一棵n个点的有根树,其中1号点是根节点.Bob在每个点上涂了颜色,并且每个点上的颜色不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qaL8P3.html" rel="bookmark" class="title">STM32 Cube固件库编程之新建工程</a>
					<div>
						Cube固件库是ST现在主推的固件库,并且在它的官网已经找不到原来的标准库可供下载.Cube固件库的构架图如下 这种新式构架可以有效的加快软件工程师的工程进度. 新建一个工程项目主要包括以下的步骤:  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0j17lAM.html" rel="bookmark" class="title">Java技术&lowbar;Java千百问（0034）&lowbar;is-a，has-a，like-a是什么</a>
					<div>
						点击进入_更多_Java千百问 1.is-a,has-a,like-a是什么 在面向对象设计的领域里,有若干种设计思路,主要有如下三种: is-a.has-a.like-a java中在类.接口.抽象 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M65QQW4.html" rel="bookmark" class="title">HDU&lowbar;1016</a>
					<div>
						#include&lt;cstdio&gt; #include&lt;cmath&gt; #include&lt;iostream&gt; #include&lt;cstring&gt; using  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M65r1y4.html" rel="bookmark" class="title">下面小编就告诉大家胡萝卜除了能明目，还有什么其他的功效吧&excl;</a>
					<div>
						﻿﻿ http://weheartit.com/goubizhong/collections/82636636-2015-01-17 http://weheartit.com/luanlutang/c ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49LEdv3.html" rel="bookmark" class="title">模板参数推导</a>
					<div>
						模板参数推导(template argument deduction),是在调用C++的模板函数时,由编译器根据使用上下文来推断所调用的模板函数的模板参数.这一概念也适用于类的模板成员函数. 类模板也 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47w9194.html" rel="bookmark" class="title">ARM GIC-400 寄存器</a>
					<div>
						1.简介 GIC-400是用于控制中断的.在cubieboard2 上 的A20芯片采用了这款控制器. cubieboard2 的GIC控制器 的地址是0x01C80000---0x01C87FFF  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0Kv2BYM.html" rel="bookmark" class="title">【转】一句话的设计模式</a>
					<div>
						原文地址:http://www.cnblogs.com/lzhlyle/p/4696645.html 1. 创建型: (1)单例:只需一个实例时考虑. (2)工厂方法:一般先用工厂方法解决对象创建问题 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPvO8n3.html" rel="bookmark" class="title">MySQL 主从复制排错</a>
					<div>
						MySQL					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vB1ja3.html" rel="bookmark" class="title">安装GDB和GDBSERVER</a>
					<div>
						转自http://www.360doc.com/content/10/0407/17/155970_21971613.shtml 把GDBSERVER装入文件系统 转自http://www.arm9h ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RmKgvM.html" rel="bookmark" class="title">Gridview 自定义外观</a>
					<div>
						private void Form1_Load(object sender, EventArgs e) { //汉化,需要引用DevExpress.Localization.v11.2.dll Dev ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0klK2d3.html" rel="bookmark" class="title">Python数据分析之numpy学习</a>
					<div>
						Python模块中的numpy,这是一个处理数组的强大模块,而该模块也是其他数据分析模块(如pandas和scipy)的核心. 接下面将从这5个方面来介绍numpy模块的内容: 1)数组的创建 2)有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPeVLB0.html" rel="bookmark" class="title">什么样的RPC才是好用的RPC</a>
					<div>
						什么样的RPC才是好用的RPC 现在RPC框架很多,但是真正好用的RPC却是少之又少.那么什么是好用的RPC,什么是不好用的RPC呢,有一个评判标准吗?下面是我列举出来的衡量RPC好用与否的几条标准: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ne9XXM.html" rel="bookmark" class="title">v&dollar;log and v&dollar;logfile</a>
					<div>
						我查询v$log和v$logfile比较混乱,不知道什么时候该查询哪个. 上图来源于Oracle官方文档 V$LOG:显示从控制文件中的redo log文件信息 V$LOGFILE:标识redo lo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4An2edM.html" rel="bookmark" class="title">【Unix环境高级编程】编写变长参数函数</a>
					<div>
						文件的格式输入输出函数都支持变长参数.定义时,变长参数列表通过省略号'...'表示, 因此函数定义格式为: type 函数名(parm1, parm2,parmN,...); Unix的变长参数通过v ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eY81g0.html" rel="bookmark" class="title">&lbrack;转&rsqb; ArcEngine 产生专题图</a>
					<div>
						小生原文 ArcEngine 产生专题图 ArcEngine提供多个着色对象用于产生专题图,可以使用标准着色方案,也可以自定义着色方案,ArcEngine提供8中标准着色方案. 一.SimpleRen ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
